// client-side oportunistic modelling of "business-objects":
// Query, Queryset, Component? 
var page_record_count = 10;
var formatquerystring_len = 25;

function Collection(index, name){
	this.index = index;
	this.name = name;
};
var collections  = [];


function Query(collection, columns, query , squery) {
	this.collection = collection;   // []
	this.columns = columns;         // string
	this.query = query;	         //sctext
	this.squery = squery;
	this.listid = "";
	this.container = {};
	// page
	this.startRecord = 1;
	this.maximumRecords = parseInt(this.startRecord) + page_record_count - 1;
	
	// repository
	this.repository = 1;
	
	this.columns_widget = null;
};

Query.prototype.load  = function(json) {
	//var collection_text = Query.collectiontext(json);
	
	var columns_text = "";
	if (json.columns != "null"){
		$.each(json.columns,function(i,item){
			columns_text = columns_text + "," + item;
		});
		if (columns_text.length > 1) {
			columns_text = columns_text.substring(1);	
		}
	}
	this.columns = columns_text;
	
	var collection = [];
	if (json.collections != "null"){
		$.each(json.collections,function(i,item){
			var coll = new Collection(item.index, item.name);
			collection[i] = coll;
		});
	}
	this.collection = collection;
	if (json["querystring"] == "[NULL]"){
		this.query = null;
	} else {
		this.query = json["querystring"];	
	}
	if (json["squerystring"] == "[NULL]"){
		this.squery = null;
	} else {
		this.squery = json["squerystring"];	
	}
	this.columns = columns_text;
};

Query.prototype.getcolumnstext = function (){
	
	if (this.columns_widget == null ) {
		return this.columns;
	}
	return this.columns_widget.getColumnsListText();
};

Query.prototype.query_uri = function () {
	var params = "?";
	if (this.query != null) {
		params = params + "q=" + escape(this.query) + "&";
	}
	if (this.squery != null) {
		params = params + "squery=" + escape(this.squery) + "&";
	}
	params = params + "collection=" + this.getcollectiontext("index") + "&columns=" + this.getcolumnstext() + "&startRecord=" + this.startRecord + "&maximumRecords=" + this.maximumRecords + "&repository=" + this.repository;
	return params;
	//return $.param(this.query);
};

Query.prototype.query_json = function () {	
	var jsonq = {"squerystring":this.squery, 
				 "querystring":this.query,				  
				 "collections" : this.getcollectiontext("index"), 
				 "columns" : this.columns,
				 "startRecord" : this.startRecord,
				 "maximumRecords" : this.maximumRecords};
	return JSON.stringify(jsonq);
};
/*
Query.prototype.getcolumnstext = function(what) {
	var columns_text = "";
	for (var i = 0; i < this.columns.length; i++) {
		if (what == "index") {
			columns_text = columns_text + "," + this.columns[i];
		} else {
			columns_text = columns_text + "," + this.columns[i];	
		}
	}
	if (columns_text.length > 1) {
		columns_text = columns_text.substring(1);	
	}
	return columns_text;
};
*/

Query.prototype.getcollectiontext = function(what) {
	var collection_text = "";
	for (var i = 0; i < this.collection.length; i++) {
		if (what == "index") {
			collection_text = collection_text + "," + this.collection[i].index;
		} else {
			collection_text = collection_text + "," + this.collection[i].name;	
		}
	}
	if (collection_text.length > 1) {
		collection_text = collection_text.substring(1);	
	}
	return collection_text;
};
Query.prototype.getcollectionindextext = function() {
	var collection_text = "";
	for (var i = 0; i < this.collection.length; i++) {
		collection_text = collection_text + "," + this.collection[i].index;
	}
	if (collection_text.length > 1) {
		collection_text = collection_text.substring(1);	
	}
	return collection_text;
};

Query.collectiontext = function(json) {
	var collection_text = "";
	if (json.collections != "null"){
		$.each(json.collections,function(i,item){
			collection_text = collection_text + "," + item.name;
		});
		if (collection_text.length > 1) {
			collection_text = collection_text.substring(1);	
		}
	}
	return collection_text;
};

Query.fullformatstring = function (json) {
	var qs = json.querystring;
	var sqs = json.squerystring;
	
	if (qs == "[NULL]") {
		qs = null;
	}
	if (sqs == "[NULL]") {
		sqs = null;
	}
	var collection_text = Query.collectiontext(json);
	
	var full_str = "";
	var len = formatquerystring_len;
	
	if (sqs != null) {
		if (sqs.length > len){
			full_str = sqs.substring(0,len) + "..| ";
		} else {
			sqs = sqs + "                                     ";
			full_str = sqs.substring(0,len) + "  | ";
		}
	}
	if (qs != null) {
		qs = Query.simplequerystring(qs);
		if (qs.length > len){
			full_str = full_str + qs.substring(0,len) + "..| ";
		} else {
			qs = qs + "                                     ";
			full_str = full_str + qs.substring(0,len) + "  | ";
		}
	}
	if (collection_text.length > (len - 6)) {
		full_str = full_str + collection_text.substring(0,len);
	} else {
		full_str = full_str + collection_text;
	}
	
	return full_str;
};

Query.queryliststring = function(squery, query) {
	var s_squery = "";
	var s_query = "";
	var str = "";
	
	if (squery != null){
		s_squery = squery;
	}
	if (query != null){
		s_query = query;
	}
	if (s_squery.length != 0 && s_query.length != 0){
		str = squery + " & (" + Query.simplequerystring(query) +  ")";
	} else if (s_squery.length != 0) {
		str = squery;
	} else {
		str =  Query.simplequerystring(query);
	}
	return str;
};

Query.simplequerystring = function (querystring) {

	if (querystring == null){
		return "";
	}
	querystring = Url.decode(querystring);
	
	var arr_and = querystring.split(" and ");
	var simple_form = "";
	var simple_form_all = "";
	var rel = "";
	
	for( var i=0;i<arr_and.length;i++){
		arr_and[i] = $.trim(arr_and[i]);
		var arr_or = arr_and[i].split(" or ");
		simple_form = "";
		for( var j=0;j<arr_or.length;j++){
			arr_or[j] = $.trim(arr_or[j]);
			while (arr_or[j].substring(0,1) == "(" ) {
				arr_or[j] = arr_or[j].substring(1,arr_or[j].length);
				arr_or[j] = $.trim(arr_or[j]);
			}
			while ( arr_or[j].substring(arr_or[j].length-1) == ")"){
				arr_or[j] = arr_or[j].substring(0,arr_or[j].length-1);
				arr_or[j] = $.trim(arr_or[j]);
			}
			if (j > 0) { 
				rel = " or ";
			} else {
				rel = "";
			}
			simple_form = simple_form + rel + arr_or[j];
		}
		if (arr_or.length > 1){
			simple_form = "(" + simple_form + ") ";
		}
		if (i > 0) { 
			rel = " and  ";
		} else {
			rel = "";
		}
		simple_form_all = simple_form_all + rel + simple_form;
		
	}
	
	
	//notifyUser("querystring:" + querystring, 'debug');
	//notifyUser("simplequerystring:" + simple_form_all, 'debug');
	return simple_form_all;
};

Query.prototype.render = function () {
	var x = "<div id='" + this.listid + "' class='query_wrapper ui-widget' ><div class='query_header ui-widget-header ui-state-default ui-corner-top'>" +
	"<span class='cmd cmd_get'></span><span class='cmd cmd_save'></span><span class='cmd cmd_del'> </span>" +
	"<span class='query_id'>" + 	this.listid + "</span>: <span class='query'>" +
	this.getcollectiontext("name") + ":" + Query.queryliststring(this.squery, this.query) + "</span>" +
			"<a class='cmd cmd_xml' target='_blank' href='" + this.link("xml") + "'>xml</a> <a class='cmd cmd_link' target='_blank' href='" + this.link("fullpage") + "' >link</a></div>" +
		//	<span class='cmd cmd-xml'></span><span class='cmd cmd-page'></span><span class='cmd cmd-link'></span></div>" +		
			//"<div class='ui-context-dialog columns-wrapper'><div class='query-columns'></div><span class='cmd cmd_del'></span></div><div class='result ui-widget-content ui-corner-bottom'></div>";
			"<div class='result ui-widget-content ui-corner-bottom'></div>";
	addToQuerylist(x);	
	
	this.container = $('#' + this.listid );
	
//	this.columns_widget = new ListWidget($(this.container).find('.query-columns'));
	//$(this.container).find('.query-columns').append(this.columns_widget);
	
	//this.columns_widget.load(this.columns.split(','));
	//this.columns_widget.initAutocomplete(element_autocomplete);
	//$(this.container).find('.columns-wrapper').hide();
	notifyUser("DEBUG: setting up removing query:" + $(this).closest('.query_wrapper').attr('id'));
	$(this.container).children('.query_header').find('.cmd_del').live('click',  function(event) {
		notifyUser("DEBUG: removing query:" + $(this).closest('.query_wrapper').attr('id'));
		queryset.removequery($(this).closest('.query_wrapper').attr('id'));
	});
	
	/*
	$(this.container).children('.columns-wrapper').children('.cmd_del').live('click',  function(event) {
		$(this).parent().hide();
	});
	*/	
 };

 Query.prototype.open = function (type) {
	 if (type != null)
	    window.open(this.link(type));
	 else
		window.open(this.link());
};
 
 Query.prototype.link = function (type) {
	 var uri="";
	 if (type=="fullpage")  {
		//var jsonq = {"squerystring":this.squery, "querystring":this.query, "searchclauses":"null" , "collections" : this.json_coll, "columns" : this.json_cols};
		//uri = "?query=" + JSON.stringify(jsonq) + "&startRecord=" + this.startRecord + "&maximumRecords=" + this.maximumRecords;
		 //uri = this.query_json();
		 uri = link('base',this.query_uri());
	 } else {
		 uri = link('recordset',type, this.query_uri());		
	 }
	return uri;
 };
  
 Query.prototype.link_obsoleted = function () {
	 
		// JSON conversion
	 /*
		if (this.query.length == 0){
			xqstring = "[NULL]";
		} else {
			xqstring = this.query;
		}
		if (this.squery.length == 0){
			xsquery = "[NULL]";
		} else {
			xsquery = this.squery;
		}
	 */
	 	var jsonq = {"squerystring":this.squery, "querystring":this.query, "searchclauses":"null" , "collections" : this.json_coll, "columns" : this.json_cols};

		var uri = "?query=" + JSON.stringify(jsonq) + "&startRecord=" + this.startRecord + "&maximumRecords=" + this.maximumRecords;
		return uri;
};

 Query.prototype.submit = function () {
		
	
		var uri = link('recordset','htmltable', this.query_uri());
		
		notifyUser("submitting query:" +  uri);
		this.container.find('.result').load( uri, function() {
					notifyUser("result-loaded",'debug');
					
					var get = $(this).parent().find('.cmd_get');				

					get.removeClass('cmd_get');
					get.addClass('cmd_up');
					// get.show();
					
					var result_header = $(this).children('.result-header');
					
					var q_header;
					q_header = $(this).parent().find('.query_header');					
					q_header.append(result_header);					
					q_header.find('.cmd_reload').click(function() {
						var qid = $(this).closest('.query_wrapper').attr("id");
						queryset.resubmit(qid);
					});
					q_header.find('.cmd_prev').click(function() {
						var qid = $(this).closest('.query_wrapper').attr("id");
						queryset.next(qid,-1);
					});
					q_header.find('.cmd_next').click(function() {
							var qid = $(this).closest('.query_wrapper').attr("id");
							queryset.next(qid,1);
					});
					
					q_header.find('.columns-wrapper').hide();
					q_header.find('.cmd_columns').live('click',  function(event) {
						notifyUser("DEBUG: submit() .cmd_columns");
						$(this).closest('.query_wrapper').find('.columns-wrapper').toggle();
					});	
			
				});

	};
	
Query.prototype.resubmit = function () {
	
	
	var uri = link('recordset','htmltable', this.query_uri());
	var qid = this.listid;
	var q_uri = this.query_uri();
	
	notifyUser("resubmitting query:" +  uri);
	
	var get = $('#' + qid ).find('.cmd_up');
	if (get.length == 0) {
		get = $('#' + qid ).find('.cmd_down');
	}
	get.addClass('cmd_get');
	get.removeClass('cmd_up');
	get.removeClass('cmd_down');
	// get.show();	

	$('#' + qid ).children('.result').children().remove();
	$('#' + qid ).find('.result').load( uri, function() {
				// update link-hrefs
				var qid = $(this).closest('.query_wrapper').attr("id");
				notifyUser("result-loaded ID:" + qid,'debug');
				
				var q = queryset.getQuery(qid);
				$('#' + qid ).find(".cmd_link").attr("href", q.link("fullpage"));
				
				var get = $(this).parent().find('.cmd_get');				
				get.removeClass('cmd_get');
				get.addClass('cmd_up');
				// get.show();	
				
				var result_header = $(this).children('.result-header');
				
				var q_header;
				q_header = $(this).parent().find('.query_header');
				q_header.children('.result-header').remove();
				
				q_header.append(result_header);					
				q_header.find('.cmd_reload').click(function() {
					var qid = $(this).closest('.query_wrapper').attr("id");
					queryset.resubmit(qid);
				});
				q_header.find('.cmd_prev').click(function() {
					var qid = $(this).closest('.query_wrapper').attr("id");
					queryset.next(qid,-1);
				});
				q_header.find('.cmd_next').click(function() {
						var qid = $(this).closest('.query_wrapper').attr("id");
						queryset.next(qid,1);
				});
				q_header.find('.cmd_columns').live('click',  function(event) {
					notifyUser("DEBUG: resubmit() .cmd_columns");
					$(this).closest('.query_wrapper').find('.columns-wrapper').show();
				});	
			});

};



var queryset_container = $("#querylist"); 

var queryset = { queries: [],
	container: '#querylist',
		
	addquery: function (query){
			
		this.queries[this.queries.length] = query;
		query.listid = "q" + this.queries.length;
		query.render();				
		query.submit();		
		//$('#querylist').html(this.render());
	},

	removequery: function (qid) {
		notifyUser("removing query:"  + qid);
		
		 for (var i = 0; i < this.queries.length; i++) {
			if (this.queries[i].listid == qid) {
				this.queries.splice(i, 1);
			} 
		}	
		$('#' + qid).remove();
		notifyUser("query removed, new queries.length:"  + this.queries.length);
		
	},

	getsquery: function(qid) {
		var qstring = "";
		
		for (var i = 0; i < this.queries.length; i++) {
			if (this.queries[i].listid == qid) {
				qstring = this.queries[i].squery;
			} 
		}
		if (qstring == null){
			qstring = "";
		}
		return qstring;
	},
	getquerystring: function(qid) {
		var qstring = "";
		
		for (var i = 0; i < this.queries.length; i++) {
			if (this.queries[i].listid == qid) {
				qstring = this.queries[i].query;
			} 
		}
		if (qstring == null){
			qstring = "";
		}

		return qstring;
	},
	getcollections: function(qid) {
		var coll = "";
		var json_coll, json_temp;
		
		for (var i = 0; i < this.queries.length; i++) {
			if (this.queries[i].listid == qid) {
				coll = this.queries[i].collection;
			} 
		}		
		if (coll.length == 0) {
			json_coll = {};
			json_coll = "null";
		} else { 
			json_coll = [{}];
			for (var i = 0; i < coll.length; i++) {
				json_coll[i] = {"index" : coll[i].index, "name" :coll[i].name};
			}
		}
		return json_coll;
	},
	
	getcolumns: function(qid) {
		var cols = "";
		var json_cols, json_temp;
		
		for (var i = 0; i < this.queries.length; i++) {
			if (this.queries[i].listid == qid) {
				cols = this.queries[i].columns;
			} 
		}
		
		if (cols == "") {
			json_cols = {};
			json_cols = "null";
		} else {  
			var pos = cols.indexOf(",", 0);
			var i = 0;
			
			json_cols = [{}];
			while (pos > -1){
				if (pos > -1){
					json_cols[i] = cols.substring(0,pos);
				} else {
					json_cols[i] = cols;
				}
				cols = cols.substring(pos+1);
				pos = cols.indexOf(",", 0);
				i = i+1;
			}
			
			json_cols[i] = cols;

			
		}
		return json_cols;
	},
	
	resubmit: function(qid){
		var query = queryset.queries[qid.substring(1)-1];
		
		query.repository = parseInt(getSelectedRepository());
		query.startRecord = $('#' + qid ).find('.start_record').val();
		query.maximumRecords = $('#' + qid ).find('.maximum_records').val();
		query.resubmit();

	},
	
	getQuery: function(qid){
		var query = queryset.queries[qid.substring(1)-1];
		return query;
	},
	
	next: function(qid,pages){
		var query = queryset.queries[qid.substring(1)-1];
		var start = 0;
		var num = 0;
		var max_value = $('#' + qid ).find('.result-header').attr("max_value");
		
		if (parseInt(query.startRecord) + pages * page_record_count >= 1){
			start =	parseInt(query.startRecord) + pages * page_record_count ;
		} else if (parseInt(query.startRecord) + pages * page_record_count + page_record_count - 1 >= 1){
			start =	1 ;
		}
	
		if (start > 0){
			if (start + page_record_count - 1 <= max_value) {
				num = page_record_count;
			} else if (start <= max_value){
				num = max_value - start;
			}
			
			if (num > 0){
				query.startRecord =	start;
				query.maximumRecords = num;
				query.resubmit();
			}
		}
		
		//$('#' + qid ).find('.start_record').val(query.startRecord);
		//$('#' + qid ).find('.maximum_records').val(query.maximumRecords);
		//var max_results = 
		
	}
	
	
};

$('#querylist .cmd_columns').live('click',function(){
	notifyUser("DEBUG: #querylist.cmd_columns");
	$(this).closest('.query_wrapper').find('.columns-wrapper').toggle();
});


$('.cmd_del').live('click',function(){
	if ($(this).parent().attr('class') == 'columns-wrapper'){
		$(this).parent().hide();
	}
});