<?xml version="1.0"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:my="myFunctions">

<!-- 
<purpose>generic templates for MDService2</purpose>
<history>
	<change on="2010-03-19" type="created" by="vr">based on 3RMA/suki/dc4_commons.xsl</change>			
	<change on="2010-03-23" type="changed" by="vr">really started rework - added html wrapper, ...</change>			
	<change on="2010-12-29" type="changed" by="vr">extracted function into: cmd_functions.xsl</change>
</history>

-->

<xsl:include href="cmd_functions.xsl"/>

<!--<xsl:include href="params.xsl"/>-->

<!-- <xsl:param name="mode" select="'html'" /> -->

<!-- moved to cmd_functions.xsl-->
<!--<xsl:param name="dict_file" select="'dict.xml'" />-->
<!--<xsl:variable name="dict" select="document($dict_file)" />-->
<!--<xsl:variable name="terms_setup" select="document($terms_setup_uri)" />-->
<!--<xsl:variable name="terms_flat" select="document($terms_flat_uri)" />-->



<!-- params for include-processing 
moved to params.xsl
	<xsl:param name="components_uri" select="'http://catalog.clarin.eu/ds/ComponentRegistry/rest/registry/components/'" />		
	<xsl:param name="prefix_replace" select="'file:///C:/Users/master/3lingua/clarin/CMDI/_repo2/metadata/toolkit/components'" />
-->

	<xsl:param name="src_file" />	
	<!--  FIXME: he? -->	
	<xsl:param name="root_uri" select="$src_file" />		

<xsl:template match="/">
		<xsl:message>root_document-uri:<xsl:value-of select="$root_uri" /></xsl:message>
		<xsl:message>components_uri:<xsl:value-of select="$components_uri" /></xsl:message>
	  	<xsl:choose>    		
    	 	<xsl:when test="contains($format,'htmlpage')" >
    	 		<xsl:call-template name="html"/>    
    	 	</xsl:when>
    	 	<xsl:otherwise>    	 		
    	 		<xsl:call-template name="continue-root"/>    
    	 	</xsl:otherwise>
    	 </xsl:choose>
</xsl:template>


<xsl:template name="html">

	<html>
	<head>
	<title><xsl:value-of select="$title"/></title>

	<link rel="stylesheet" href="{$base_dir}/style/jquery/clarindotblue/jquery-ui-1.8.5.custom.css" type="text/css" />
	<link href="{$base_dir}/style/jquery/jquery-treeview/jquery.treeview.css" rel="stylesheet" />
	<link href="{$base_dir}/style/jquery/treetable/jquery.treeTable.css" rel="stylesheet" ></link>
	<link href="{$base_dir}/style/cmds-ui.css" type="text/css" rel="stylesheet"></link>
	
	<link href="{$base_dir}style/jquery/jquery-textboxlist/TextboxList.css" rel="stylesheet" type="text/css"></link>
	<link href="{$base_dir}style/jquery/jquery-autocomplete/jquery.autocomplete.css" rel="stylesheet" type="text/css"></link>

	<script src="{$base_dir}/scripts/jquery/js/jquery-1.4.2.js" type="text/javascript"></script>
	<script src="{$base_dir}/scripts/jquery/js/jquery-ui-1.8.5.custom.min.js" type="text/javascript"></script>
	<script src="{$base_dir}/scripts/jquery/jquery-treeview/jquery.treeview.js" type="text/javascript"></script>
	<script src="{$base_dir}/scripts/jquery/jquery-treeTable/jquery.treeTable.js" type="text/javascript"></script>
	<!-- <script src="scripts/jquery/jquery-autocomplete/jquery.autocomplete.js" type="text/javascript"></script>
	
	<script src="scripts/mdservice_searchclause.js" type="text/javascript"></script>
	<script src="scripts/mdservice_model.js" type="text/javascript"></script>
	<script src="scripts/mdservice2_ui.js" type="text/javascript"></script>
	  -->

   	<xsl:call-template name="callback-header"/> 
	</head>
	<body>
		<h1><xsl:value-of select="$title"/></h1>		
			<xsl:call-template name="continue-root"/>    
	</body>
	</html>
</xsl:template>

<xsl:template name="callback-header">

</xsl:template>

<!-- 
<xsl:template name="continue-root">

</xsl:template>
 -->
    <!-- Start includes -->
    
    <!-- resolve includes -->
    <xsl:template match="@*|node()" mode="include">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()" mode="include"/>
        </xsl:copy>
    </xsl:template>


    <xsl:template match="CMD_Component[@ComponentId]" mode="include">
    
    		<!-- <xsl:param name="resolved_path" select="if (matches(@filename, $prefix)) then $prefix_replace else './'" /> -->

    		<!-- <xsl:variable name="resolved_fn" select="if (matches(@filename, $prefix)) then replace(@filename, $prefix, $prefix_replace) else if (document-uri(/)) then @filename else concat( $root_uri, '/', @filename)" /> -->
    		<!--  <xsl:variable name="resolved_fn" select="concat($components_uri, @ComponentId)" />  -->
    		<xsl:variable name="resolved_fn" select="concat($components_uri, my:extractID(@ComponentId))" />   
    	    <xsl:variable name="compid" select="@ComponentId" /> 
	        
        <!-- <xsl:variable name="resolved_fn" select="replace(@filename, 'http://www.clarin.eu/cmd/components', 'file:///C:/Users/master/3lingua/clarin/CMDI/_repo2/metadata/toolkit/components')" /> -->
        
        <xsl:message>resolved_fn:<xsl:value-of select="$resolved_fn" /></xsl:message>
        <xsl:message>document-uri:<xsl:value-of select="document-uri(/)" /></xsl:message>
        <!-- some of the outer CMD_Component attributes can overwrite the inner CMD_Component attributes -->
        
        <xsl:variable name="outer-attr" select="@CardinalityMin|@CardinalityMax"/>
        <xsl:for-each select="document($resolved_fn)/CMD_ComponentSpec/CMD_Component">
            <xsl:variable name="inner-attr" select="@*"/>
            <xsl:copy>
            		<!-- <xsl:attribute name="filename" select="replace($resolved_fn,$prefix_replace,'')" /> -->
            	
           		<xsl:attribute name="ComponentId" select="$compid" />
                <xsl:apply-templates select="$outer-attr" mode="include"/>
                <xsl:apply-templates select="$inner-attr[not(node-name(.) = $outer-attr/node-name(.))]" mode="include"/>
                <xsl:apply-templates select="node()" mode="include">
        <!--        	<xsl:with-param name="resolved_path" select="$resolved_path" /> -->
                </xsl:apply-templates>
            </xsl:copy>
        </xsl:for-each>
    </xsl:template>
    

    <xsl:template match="componentDescription[id] | profileDescription[id]" mode="include">
    
    	<!--  <xsl:variable name="resolved_uri" select="concat($root_uri, '/', id)" />-->
    	<xsl:variable name="resolved_uri" select="concat($cmdprofiles_uri , '/', my:extractID(id))" /> 
    	
        
        <xsl:message>resolved_uri:<xsl:value-of select="$resolved_uri" /></xsl:message>
        <xsl:message>document-uri:<xsl:value-of select="document-uri(/)" /></xsl:message>
                
        <xsl:copy>        	
        	<xsl:apply-templates mode="include" />
        	<xsl:apply-templates select="document($resolved_uri)" mode="include" />
        	<!-- <xsl:copy-of select="document($resolved_uri)" /> -->
       		<!-- <xsl:copy-of select="document(id, $root_uri)" />  -->
        </xsl:copy>
    </xsl:template>
        
    <!-- Stop includes -->

<!--  generic templates -->
<xsl:template name="attr-detail-div" >
		<div class="detail">
			<xsl:for-each select="@*" >
				<div class="cmds-elem-prop"><span class="label"><xsl:value-of select="name()" />: </span>
					<span class="value"><xsl:value-of select="." /></span></div>
			</xsl:for-each>
		</div>
</xsl:template>

<xsl:template name="format-field" >
	<xsl:param name="elems" />
  					<xsl:choose>
  						 <xsl:when test="count($elems/*) &gt; 1" >
  						 	STRUCTURE!
		  					<ul>
			  					<xsl:for-each select="$elems" >		  					
			  						<li><xsl:call-template name="format-value" /></li>
			  					</xsl:for-each>
		  					</ul>
		  				</xsl:when>
		  				<xsl:when test="count($elems) &gt; 1" >
		  					<ul>
			  					<xsl:for-each select="$elems" >		  					
			  						<li><xsl:call-template name="format-value" /></li>
			  					</xsl:for-each>
		  					</ul>
		  				</xsl:when>
		  				<xsl:otherwise>
		  					<xsl:call-template name="format-value">
		  						<xsl:with-param name="value" select="$elems" />
		  					</xsl:call-template>		  					
		  				</xsl:otherwise>  			
			  		</xsl:choose>
					 
</xsl:template>

<xsl:template name="format-value" >
<xsl:param name="value" select="."/>
	<!-- cnt_value:<xsl:value-of select="count($value)" />  -->
  					<xsl:choose>
  						 <xsl:when test="starts-with($value[1], 'http:') " >
								<a target="_blank" class="external" href="{$value}"><xsl:value-of select="$value"></xsl:value-of></a>
						</xsl:when>
						<xsl:otherwise>
								<xsl:value-of select="$value" />
						</xsl:otherwise>
					</xsl:choose>
</xsl:template>  				



</xsl:stylesheet>