﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet  version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"    xmlns:my="myFunctions"
>
<!-- 
<purpose> generate all the views for terms-matrix</purpose>
<params>
<param name=""></param>
</params>
<history>
	<change on="2010-10-11" type="created" by="vr">from model2view.xsl</change>		
</history>
-->
<xsl:import href="cmd_commons.xsl"/>

<xsl:output method="xml" />  

<!-- <xsl:param name="size_lowerbound">0</xsl:param>
<xsl:param name="max_depth">0</xsl:param>
<xsl:param name="freq_limit">20</xsl:param>
<xsl:param name="show">file</xsl:param> 
<xsl:param name="detail_uri_prefix"  select="'?q='"/> 
<xsl:param name="mode" select="'htmldiv'" /> -->

<xsl:param name="sort">x</xsl:param> <!-- s=size|n=name|t=time|x=default -->
<xsl:param name="name_col_width" >50%</xsl:param>
<xsl:param name="title" select="'Terms'" />

<xsl:decimal-format name="european" decimal-separator=',' grouping-separator='.' />

<xsl:template name="continue-root">
	<div>	
		<xsl:choose>    	 	
    	 	 <xsl:when test="$format='terms2htmltable'" >
    	 		<xsl:call-template name="header"/>    
    	 		<xsl:call-template name="table"/>
    	 		    
    	 	</xsl:when>
    	 	<xsl:when test="$format='terms2htmlpage'" >
    	 		<xsl:call-template name="header"/>
			    <div id="terms-matrix">
			    	<xsl:apply-templates select="Termsets/Termset" mode="terms-tree" />			    	
				</div>	    	 								    		
	  	 	</xsl:when>	  	 	     	
     	 	<xsl:when test="$format='terms2htmllist'" >    	 		
    	 		<xsl:call-template name="list"/>    
    	 	</xsl:when>
    	 	<xsl:when test="$format='terms2flat'" >    	 		    	 	    	 		
    	 			<xsl:call-template name="terms-flat"/>    	 		    	 		    
    	 	</xsl:when> 
    	 	<xsl:when test="$format='terms2autocomplete'" >
    	 		<xsl:variable name="terms_flat" >    	 	    	 		
    	 			<xsl:call-template name="terms-flat"/>
    	 		</xsl:variable>    	 		
    	 		<xsl:apply-templates select="$terms_flat" mode="autocomplete"/>    	 		    
    	 	</xsl:when> 
    	 	<xsl:when test="$format='terms2htmlselect'" >
			      		<select id="terms-select">		
		    	 				<xsl:apply-templates select=".//Termset" mode="select"/>		    	 				
		    			</select>	    	 				    		
	    	 	</xsl:when>
    	 	<xsl:otherwise>
    	 		<xsl:call-template name="list"/>    
    	 	</xsl:otherwise>
    	 </xsl:choose>
    </div>	 
	
</xsl:template>	


<xsl:template name="header">
	<h2>MDService Terms</h2>	
	<table>
		<tbody>
			<tr><td>count Termsets</td><td align="right"><xsl:value-of select="count(/Termsets/Termset)"/></td></tr>												
		</tbody>
	</table>
</xsl:template>		

<xsl:template name="table">
	<table>
		<caption>Terms Usage</caption>
		<thead><tr><th>name/path</th><th>count elems</th><th>count text</th><th>count distinct text</th>
		<th>context</th><th>corresp comp</th><th>datcat</th></tr></thead>
		<tbody>		
			<xsl:apply-templates select="*" mode="table" />			
		</tbody>
	</table>

</xsl:template>

<xsl:template match="Term" mode="table">
				<tr><td><a href="?q={@path}" >
					<xsl:value-of select="translate(@path,'/','.')"/></a></td>
						<td align="right"><xsl:value-of select="@count"/></td>
						<td align="right"><xsl:value-of select="@count_text"/></td>						
						<td align="right"><xsl:value-of select="@count_distinct_text"/></td>						
						<td><xsl:value-of select="@context"/></td>
						<td><xsl:value-of select="@corresponding_component"/></td>
						<td><xsl:value-of select="@datcat"/></td>
						
				</tr>							
				<xsl:apply-templates select="*" mode="table" />			
</xsl:template>

<xsl:template name="list">
	<div class="terms">		
		<!--  format:<xsl:value-of select="$format" /> -->
		<!--<xsl:variable name="translated_term" select="translate(replace(/*/Term[1]/@path,'//',''),'/','.')" />
		 <input id="query_terms" value="{$translated_term}" /> -->		
		<ul class="treeview">
			<xsl:apply-templates select="/*/Term[@path]" mode="list" />			
		</ul>	
	</div>
</xsl:template>

<xsl:template match="Term" mode="list" >
<xsl:param name="options" select="''" />
		<!--  <xsl:variable name="translated_path" select="translate(replace(@path,'//',''),'/','.')" /> -->
		<!--  filter out empty datcats  -->
		<xsl:if test="@elem or descendant::*[@elem] or $options='all'" >
				<li><div class="cmds-elem-plus"><span class="detail-caller"><!-- <a href="{concat($detail_model_prefix,@context)}" >  -->
					<xsl:value-of select="@path"/></span>
					<span class="note">|<xsl:value-of select="@count"/>|</span>
					<!--  /<xsl:value-of select="@count_text"/>/<xsl:value-of select="@count_distinct_text"/> -->					
					<span class="data comppath"><xsl:value-of select="@path" /></span>		 
					<span class="cmd cmd_filter"><xsl:text> </xsl:text></span>
					<span class="cmd cmd_detail" ><xsl:text> </xsl:text></span>
					<span class="cmd cmd_columns" ><xsl:text> </xsl:text></span>
					<xsl:call-template name="attr-detail-div" />
						<!--  <div class="detail">
							<xsl:for-each select="@*" >
								<div class="cmds-elem-prop"><span class="label"><xsl:value-of select="name()" />: </span>
									<span class="value"><xsl:value-of select="." /></span></div>
							</xsl:for-each>
						</div> -->
					</div>
					<ul><xsl:apply-templates select="Term" mode="list" >
							<xsl:with-param name="options" select="$options"></xsl:with-param>
						</xsl:apply-templates>
					</ul>				
				</li>	
		</xsl:if>		
</xsl:template>


<xsl:template match="Termset" mode="terms-tree" >
					<table class="terms-tree" >
						<thead>
						<tr><th class="treecol">Name</th><th>Count Elems</th><th>Count Text</th><th>Count Distinct Text</th><th>Path</th><th>comp/datcat</th></tr>
						</thead>					
						<xsl:apply-templates select="Term" mode="detail">
							<xsl:sort order="ascending" select="@n" />							
						</xsl:apply-templates>
					</table>
</xsl:template>					

<xsl:template match="Term" mode="detail" >
<xsl:param name="parentid" select="'x-'" />

<xsl:variable name="lv" select="count(ancestor::Term)" />

	<xsl:variable name="xid" >
		<xsl:choose>
		<xsl:when test="$lv=0"><xsl:value-of select="concat($parentid,position())" /></xsl:when>
		<xsl:otherwise><xsl:value-of select="concat($parentid,'-', position())" /></xsl:otherwise>
		</xsl:choose> 
	</xsl:variable>
	
	<tr id="{$xid}" >
	  <xsl:if test="$lv!=0" >
	  	<xsl:attribute name="class" select="concat('child-of-',$parentid)" />
	  </xsl:if>
		<td class="treecol" ><xsl:value-of select="@name" /></td>		
		<td class="number"><xsl:value-of select="@count" /></td>
		<td class="number"><xsl:value-of select="@count_text" /></td>
		<td class="number"><xsl:value-of select="@count_distinct_text" /></td>
		<td><xsl:value-of select="@path" />,<xsl:value-of select="@context" /></td>			
		<td><xsl:value-of select="@corresponding_component" />,<xsl:value-of select="@datcat" /></td>
     </tr> 
		<xsl:if test="Term and ($lv&lt;$max_depth or $max_depth=0)">
			
				<xsl:choose>
					<xsl:when test="$sort='s'">				
						<xsl:apply-templates select="Term" mode="detail">
							<xsl:with-param name="parentid" select="$xid" />			
								<xsl:sort order="descending" select="@count_distinct_text" data-type="number" />
						</xsl:apply-templates>		
					</xsl:when>
					<xsl:when test="$sort='n'">				
					<xsl:apply-templates select="Term" mode="detail">
							<xsl:with-param name="parentid" select="$xid" />
								<xsl:sort order="ascending" select="@n" />
						</xsl:apply-templates>
					</xsl:when>
					<xsl:otherwise>
					<!--  testwise: show only non empty Terms-->
						<xsl:apply-templates select="Term[@count_distinct_text &gt; 1]" mode="detail">
							<xsl:with-param name="parentid" select="$xid" />								
						</xsl:apply-templates>		
					</xsl:otherwise>
				</xsl:choose>					
					
		</xsl:if>
	
</xsl:template>

<xsl:template match="Termset" mode="select">
	
	<xsl:variable name="count" select="if (Term/@count) then concat(' |',Term/@count,'|') else '' " />
	<xsl:variable name="call-value" select="if (@type='model') then @name else @id" />
	<option value="{$call-value}" ><xsl:value-of select="@name" /><xsl:value-of select="$count" /></option>					
</xsl:template>

<xsl:template match="Term" mode="autocomplete">
	<xsl:copy>
		<xsl:copy-of select="@*" />
		<div class="term-contexts">
			<ul>
				<xsl:apply-templates mode="autocomplete" />
			</ul>
		</div>
	</xsl:copy>					
</xsl:template>

<xsl:template match="context" mode="autocomplete">
	<li class="context cmds-elem-plus">
		<span class="autocomplete-select-caller">
		<!-- 
		<a href="{concat($detail_model_prefix,@path)}" >
				<xsl:value-of select="@path"/></a>
		 --> <xsl:value-of select="@path"/>
				</span>
					
		<xsl:call-template name="attr-detail-div" />
		<ul>
			<xsl:apply-templates select="context" mode="autocomplete" />
		</ul>
	</li>					
</xsl:template>


<xsl:template name="terms-flat">
	
		<!--  group union of model, dcr and rr Terms -->  
		<xsl:for-each-group select=".//Termset[@type='model']//Term | .//Termset[@type='dcr']/Term | .//Termset[@type='rr']//Term[@type='rel']" group-by="lower-case(@name)" >
<!--		<xsl:for-each-group select="//Term[exists(@name)][parent::Termset]" group-by="lower-case(@name)" >-->
			<xsl:sort select="lower-case(@name)" />
			<!--  <xsl:if test="exists(current-group()[not(@type='datcat')])" >  -->
				<Term name="{@name}">
					<xsl:for-each select="current-group()[not(@type='datcat' or @type='rel')]" >
						<context><!-- <xsl:value-of select="ancestor::Termset[1]/@id" />:  -->
							<xsl:copy-of select="@*" />
						<xsl:value-of select="@path" /></context>
					</xsl:for-each>
					<xsl:for-each select="current-group()[@type='datcat'][parent::Termset]" >
						<xsl:variable name="datcat" select="." />
						<context><xsl:copy-of select="@*" /><xsl:value-of select="ancestor::Termset[1]/@id" />:<xsl:value-of select="@name" />
						<xsl:for-each-group select="$datcat/Term" group-by="@path" >
							<context><xsl:copy-of select="@*" /><xsl:copy-of select="@*" /><xsl:value-of select="@path" /></context>
						</xsl:for-each-group>
						</context>				
					</xsl:for-each>
					
					<xsl:for-each select="current-group()[@type='rel']" >
						<xsl:variable name="datcat" select="if(parent::Term[@type='rel']) then parent::Term[@type='rel'] else . " />
								<context><xsl:copy-of select="@*" /><!-- <xsl:value-of select="ancestor::Termset[1]/@id" />: --><xsl:value-of select="@path" />
<!--						<xsl:for-each-group select="$datcat//Term[@type!='datcat']" group-by="@path" >-->
								
							<xsl:for-each select="$datcat//Term[@type='datcat']" > <!-- [Term/@path] -->
								<context><xsl:copy-of select="@*" /><xsl:value-of select="@path" />
								<xsl:for-each-group select="Term[@path]" group-by="@path" >
										<context><xsl:copy-of select="@*" /><xsl:value-of select="@path" /></context>
								</xsl:for-each-group>
								</context>
							</xsl:for-each>
						</context>				
					</xsl:for-each>
				</Term>
<!--			</xsl:if>-->
		</xsl:for-each-group>
</xsl:template>

<xsl:template name="list-datcats">
	<xsl:param name="matrix" select="."></xsl:param>
	<table>
		<caption>DatCats |<xsl:value-of select="count(distinct-values($matrix//Term/@datcat))" />| <span class="note">* Click on numbers to see detail </span></caption>
				<thead><tr><th rowspan="2">id</th><th rowspan="2">name</th>
					<th colspan="3" >count </th><th rowspan="2">elems</th></tr>
					<tr><th>profile*</th><th >all*</th><th>elems</th> </tr>		</thead>
		<tbody>		
				<xsl:for-each-group select="$matrix//Term" group-by="@datcat">
					<xsl:sort select="lower-case(@datcat)" order="ascending"/>					
						<tr><td valign="top"><xsl:value-of select="my:shortURL(@datcat)"/></td>
						<td valign="top"><xsl:value-of select="my:rewriteURL(@datcat)"/></td>
						<td valign="top" align="right">
							<span class="detail-caller" ><xsl:value-of select="count(distinct-values(current-group()/@name))"/></span>
							<div class="detail" >
									<div class="box_heading"><xsl:value-of select="my:rewriteURL(@datcat)"/></div>
									<ul>
										<xsl:for-each select="distinct-values(current-group()/@name)" >
											<li><xsl:value-of select="." /></li>
										</xsl:for-each>
									</ul>
								</div>							
						</td>
						<td valign="top" align="right">
							<span class="term_detail_caller" ><xsl:value-of select="count(current-group())"/></span>
							<div class="term_detail" >
									<div class="box_heading"><xsl:value-of select="my:rewriteURL(@datcat)"/></div>
									<ul>
										<xsl:for-each-group select="current-group()" group-by="@name" >
											<li><xsl:value-of select="@name" />
													<ul>
														<xsl:for-each select="current-group()/@context" >
																<li><xsl:value-of select="." /></li>
														</xsl:for-each>
													</ul>
											</li>
										</xsl:for-each-group>
									</ul>
								</div>							
						</td>
						<td valign="top" align="right"><xsl:value-of select="count(distinct-values(current-group()/@elem))"/></td>						
							
						<td width="40%">						
								<xsl:for-each select="distinct-values(current-group()/@elem)">
									<xsl:sort select="." />
									<xsl:value-of select="."/>,
								</xsl:for-each>
						</td>												
						</tr>					
				</xsl:for-each-group>
		</tbody>
	</table>
	</xsl:template>

<xsl:template name="callback-header" >
	<style type="text/css">
		#modeltree { margin-left: 10px; border: 1px solid #9999aa; border-collapse: collapse;}
		.number { text-align: right; }
		td { border-bottom: 1px solid #9999aa; padding: 1px 4px;}
		.treecol {padding-left: 1.5em;}
		table thead {background: #ccccff; font-size:0.9em; }
		table thead tr th { border:1px solid #9999aa; font-weight:normal; text-align:left; padding: 1px 4px;}

	</style> 
	<script type="text/javascript" >
		$(function(){
			$("#modeltree").treeTable({initialState:"expanded"});
		});
	</script>
</xsl:template>

</xsl:stylesheet>